// ===================================================================
//
// CBP_ePuck_Braitenberg_Light.c
//
// 14-09-20 RELEASE
// Controller for Braitenberg Vehicle
//
// ==================================================================

#include <webots/robot.h>
#include <webots/motor.h> 
#include <stdio.h>
#include <webots/light_sensor.h>

#include "CBP_Helper_3.h"

#define TIME_STEP 32
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 6.28
#define PI 3.14159265358979

WbDeviceTag left_motor, right_motor;
WbDeviceTag ls0, ls7;

void deviceInit() {
 // get a handler to the motors and set target position to infinity (speed control).
  left_motor = wb_robot_get_device("left wheel motor");
  right_motor = wb_robot_get_device("right wheel motor");
  wb_motor_set_position(left_motor, INFINITY);
  wb_motor_set_position(right_motor, INFINITY);
  wb_motor_set_velocity(left_motor, 0.0);
  wb_motor_set_velocity(right_motor, 0.0);

  ls0 = wb_robot_get_device("ls0");
  wb_light_sensor_enable(ls0, TIME_STEP); 
  ls7 = wb_robot_get_device("ls7");
  wb_light_sensor_enable(ls7, TIME_STEP); 
       
  }  


int main(int argc, char **argv) {

  double omegaL, omegaR;
  double leftEyeVal, rightEyeVal;
  double leftIntens, rightIntens;
  double driveL, driveR;
  
  wb_robot_init();

  deviceInit();

  while (wb_robot_step(TIME_STEP) != -1) {
     
    // Read the raw sensor values     
    // leftEyeVal =    
    // rightEyeVal =   

    // Convert to intensity values
    // leftIntens = 
    // rightIntens = 
        
    printf("leftIntens = %f, rightIntens = %f\n",leftIntens,rightIntens);

    // Normalise
    // driveL = 
    // driveR = 
    
    // Now get the wheel angular velocities
    // omegaL 
    // omegaR   
   
    wb_motor_set_velocity(left_motor,  omegaL);
    wb_motor_set_velocity(right_motor, omegaR);

  };

  wb_robot_cleanup();

  return 0;
}
