// =================================================
//
// CBP_ePuck_ObjDet_1.c
//
// 09-10-20 RELEASE
//
// Rotate robot and scan for obstacles. Rotate to
// obstacle direction and move to obstacle
//
// ==================================================

#include <webots/distance_sensor.h>
#include <webots/motor.h>
#include <webots/robot.h>
#include <webots/compass.h>
#include <webots/position_sensor.h>

#include <stdio.h>

#include "CBP_Polar_Plotter.h"
#include "CBP_Helper_4.h"

#define TIME_STEP 32
#define MAX_SPEED 6.28
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define DIST_THRESHOLD 0.5
#define TIME_TO_MOVE 5.0
// FSM
#define STATE_SCANNING 1
#define STATE_ANALYSING 2
#define STATE_ROTATETO_OBJECT 3
#define STATE_FORWARDTO_OBJECT 4
#define STATE_DONE 5

WbDeviceTag toflight;
WbDeviceTag compass;
WbDeviceTag right_motor;
WbDeviceTag left_motor;
WbDeviceTag leftWheelAngle;
  
// Initialize sensors and actuators
void init() {

  toflight = wb_robot_get_device("tof");
  wb_distance_sensor_enable(toflight,TIME_STEP);
  
  right_motor = wb_robot_get_device("right wheel motor");
  left_motor = wb_robot_get_device("left wheel motor");

  wb_motor_set_position(left_motor, INFINITY);
  wb_motor_set_position(right_motor, INFINITY);
      
  compass = wb_robot_get_device("comp1");
  wb_compass_enable(compass, TIME_STEP);

  leftWheelAngle = wb_robot_get_device("left wheel sensor");
  wb_position_sensor_enable(leftWheelAngle,TIME_STEP);
  
}

int main(int argc, char **argv) {
  
  double theta;
  double omegaL = 0.0;
  double omegaR = 0.0;
  double distArray[360];
  int thetaIndex=0;
  int state;
  double minDist=2.0;
  double wheelTheta=0;
  double wheelThetaStart=0;
  int foundIndex=0;
  
  FILE* logFile;
  logFile = fopen("Log.m", "w");
  writeOctaveHead(logFile);
    
  wb_robot_init();

  init();
   
  // Need to init this array, since not all angles may occur
  // during scanning, and so not all array values will be written to
  for(int i=0;i<360;i++) {
    distArray[i] = 2.0;
  }
    
  state = STATE_SCANNING;
  
  while (wb_robot_step(TIME_STEP) != -1) {
  
    switch(state) {
      case STATE_SCANNING:
        theta = getAngleDegrees(compass);
       
        omegaL = -0.1*MAX_SPEED;
        omegaR = 0.1*MAX_SPEED;
        double sensorVal = wb_distance_sensor_get_value(toflight);
        double dist = lookUpDistanceTOF(cTOF,sensorVal);
  
        
        printf(">>> SCANNING: theta = %f, dist = %f\n",theta,dist);       
        thetaIndex = (int)theta;
        if(thetaIndex < 0)
          thetaIndex += 360;
          
        distArray[thetaIndex] = dist;
        writeData2ToOctave(logFile,(int)theta,dist);           
        if(theta < 1 && theta > -1)
          state = STATE_ANALYSING;
        break;
      
      case STATE_ANALYSING:
        printf(">>>>> STATE_ANALYSING\n");
        omegaL = 0.0;
        omegaR = 0.0;

        // Add code here to iterate over the distArray and so
        // find the minimum distance recorded
        // minDist = 
        
        // Also log the index (angle) in the distArray
        // for this minDist
        // foundIndex = 


        printf("Object found at angle %d, distance %f\n",foundIndex,minDist);       
        state = STATE_ROTATETO_OBJECT;
       
        break;   
                   
      case STATE_ROTATETO_OBJECT:      
        omegaL = -0.1*MAX_SPEED;
        omegaR = 0.1*MAX_SPEED;
        theta = getAngleDegrees(compass);             
        if(fabs(theta - (double)foundIndex) < 2.0) {
          printf("Final theta = %f\n",theta);
          state = STATE_FORWARDTO_OBJECT;
          
          // Add a single line of code here to grab the left wheel
          // encoder value
          // wheelThetaStart = 
          omegaL = 0.5*MAX_SPEED;
          omegaR = 0.5*MAX_SPEED;

          printf("avDist = %f omegas = %f\n",minDist,omegaL);
        }
        break;
               
      case STATE_FORWARDTO_OBJECT:
        // Add a line of code to get the changing left wheel encoder
        // value. Don't forget to subtract the initial value
        // wheelTheta = 
        
        // Now add a line of code to calculate the distance gone
        // dist = 
        
        // Now complete this block so the robot stops when it has
        // reached the obstacle
        
        //if(      ) {
        //  omegaL = 
        //  omegaR =            
        //  state =     
        //}
        break; 
        
      case STATE_DONE:
        break;               
    }
    
   wb_motor_set_velocity(left_motor,  omegaL);
   wb_motor_set_velocity(right_motor, omegaR);
   
  }
 
  writeOctaveTail(logFile);
  fclose(logFile);

  wb_robot_cleanup();
  return 0;  // EXIT_SUCCESS
}
