// ===================================================================
// File:          CBP_ePuck_Odometry_1
// Date:
// 11-08-20 05-09-20 07-09-20 12-09-20 03-10-20 RELEASE
//
// Move along a striaght line to compare wheel encoders with GPS
// Can use time or distance as termination condition
//
// ==================================================================

#include <webots/robot.h>
#include <webots/motor.h> 
#include <webots/distance_sensor.h>
#include <webots/position_sensor.h>
#include <stdio.h>
#include <webots/gps.h>

#include "CBP_Plotter.h"

#define TIME_STEP 32
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 6.28
#define PI 3.14159265358979

#define STATE_MOVE 1
#define STATE_CALCULATE 2
#define STATE_DONE 3


WbDeviceTag left_motor, right_motor, gps;

void init() {

  left_motor = wb_robot_get_device("left wheel motor");
  right_motor = wb_robot_get_device("right wheel motor");
  wb_motor_set_position(left_motor, INFINITY);
  wb_motor_set_position(right_motor, INFINITY);
  wb_motor_set_velocity(left_motor, 0.0);
  wb_motor_set_velocity(right_motor, 0.0);
   
  gps = wb_robot_get_device("gps");
  wb_gps_enable(gps, TIME_STEP); 

}


int main(int argc, char **argv) {

  double omegaL, omegaR;
  double desiredDistance;
  double desiredTime;
  double speed;
  double time = 0;
  int state = STATE_MOVE;
  WbDeviceTag leftWheelAngle;
    
  FILE* plotFile;
  plotFile = fopen("Robot.m", "w");
  writeOctaveHead(plotFile);  
  
  desiredDistance = 0.5;
  desiredTime = 10.0;
  
  // Add code to calculate omegaL and omegaR here, before while loop
  // speed = 
  // omegaL = 
  // omegaR = 
    
  // Uncomment to print values printf("speed = %f, omegaL = %f, omegaR = %f\n",speed, omegaL, omegaR);
  
  wb_robot_init();

  init();
 
  leftWheelAngle = wb_robot_get_device("left wheel sensor");
  wb_position_sensor_enable(leftWheelAngle,TIME_STEP);
  
  while (wb_robot_step(TIME_STEP) != -1) {
  
    switch(state) {
      case STATE_MOVE:
        printf("\n"); // To fool compiler
        const double *gpsVals = wb_gps_get_values(gps);   
        printf("GPS value: %f  ",gpsVals[2]); 
        
        // Get wheel angle and distance gone
        // double wheelTheta = 
        // double dist = 

        // printf("Encoder angle %f distance = %f ",wheelTheta*180/PI,dist);
        // printf("Time = %f\n",time);
        // Uncommet this line writeData2ToOctave(plotFile,gpsVals[2],dist); 
                 
        // Stop on time     
        // if(some condition) {


        // } 
        
        time += TIME_STEP/1000.0;  // update time in seconds      
        break;
      case STATE_DONE:

        break;      
    
    }

    wb_motor_set_velocity(left_motor,  omegaL);
    wb_motor_set_velocity(right_motor, omegaR);

  };

  writeOctaveTail(plotFile);
  fclose(plotFile);
    
  wb_robot_cleanup();

  return 0;
}
