// ===================================================================
//
// CBP_ePuck_Sensorium_1.c
//
// 14-09-20 RELEASE
//
// Simple controller to explore distance, light and time of flight.
//
// ==================================================================

// WEbots headers
#include <webots/robot.h>
#include <webots/motor.h> 
#include <webots/distance_sensor.h>
#include <webots/light_sensor.h>

// C-function headers
#include <stdio.h>

// User function headers
#include "CBP_Helper_2.h"

// Robot Parameters Speed in rad/sec. Distances in metres.
// Time step is abnormally large to slow down data output
#define TIME_STEP 500    
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 6.28
#define PI 3.14159265358979

// Put device tags and value arrays as Global variables
WbDeviceTag left_motor, right_motor;//, left_position_sensor, right_position_sensor;
// distance sensors
char ps_names[8][4] = {"ps0", "ps1", "ps2", "ps3", "ps4", "ps5", "ps6", "ps7"};
WbDeviceTag ps[8];
double ps_vals[8];

// light sensors
char ls_names[8][4] = {"ls0", "ls1", "ls2", "ls3", "ls4", "ls5", "ls6", "ls7"};
WbDeviceTag ls[8];
double ls_vals[8];

// time-of-flight sensor
WbDeviceTag toflight;

// Do initialization in this function
void deviceInit() {
 // get a handler to the motors and set target position to infinity (speed control).
  left_motor = wb_robot_get_device("left wheel motor");
  right_motor = wb_robot_get_device("right wheel motor");
  wb_motor_set_position(left_motor, INFINITY);
  wb_motor_set_position(right_motor, INFINITY);
  wb_motor_set_velocity(left_motor, 0.0);
  wb_motor_set_velocity(right_motor, 0.0);

  // initialise infra-red distance and light sensors
  for (int i = 0; i < 8; i++) {
    ps[i] = wb_robot_get_device(ps_names[i]);
    wb_distance_sensor_enable(ps[i], TIME_STEP);
    ls[i] = wb_robot_get_device(ls_names[i]);
    wb_light_sensor_enable(ls[i], TIME_STEP);    
  }  
  
  toflight = wb_robot_get_device("tof");
  wb_distance_sensor_enable(toflight,TIME_STEP);
  
}

double invertLightSensorVals(double val) {

 
  return 0; // temporary to keep compiler happy until func created
}

int main(int argc, char **argv) {

  wb_robot_init();

  deviceInit();
    
  while (wb_robot_step(TIME_STEP) != -1) {
          
    // Time of flight
    
    
    
    // Distance Sensors


    // Invert single distance sensor

    
    // Light Sensors

    
    // Invert single light sensor
    double output = invertLightSensorVals(ls_vals[0]);
    printf("ls0 vals inverted = %f\n",output);
        

   // Do not drive robot
    wb_motor_set_velocity(left_motor,  0);
    wb_motor_set_velocity(right_motor, 0);

  };

  wb_robot_cleanup();

  return 0;
}
