// ===================================================================
//
// CBP_ePuck_Sensorium_2.c
//
// 30-09-20 RELEASE
//
// Simple controller to explore sensors: Compass and GPS
//
// ==================================================================

// WEbots headers
#include <webots/robot.h>
#include <webots/motor.h> 
#include <webots/distance_sensor.h>
#include <webots/position_sensor.h>
#include <webots/gps.h>
#include <webots/compass.h>
#include <webots/light_sensor.h>

// C-function headers
#include <stdio.h>

// User function headers
#include "CBP_Helper_2.h"

// Robot Parameters Speed in rad/sec. Distances in metres.
#define TIME_STEP 32
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 6.28
#define PI 3.14159265358979

// detection thresholds
#define DIST_THRESH 300

// States
#define STATE_ROTATE 1
#define STATE_ADVANCE 2

// Put device tags and value arrays as Global variables
WbDeviceTag left_motor, right_motor;
WbDeviceTag gps;
WbDeviceTag comp;
WbDeviceTag toflight;

void deviceInit() {
  // get a handler to the motors and set target position to infinity (speed control).
  left_motor = wb_robot_get_device("left wheel motor");
  right_motor = wb_robot_get_device("right wheel motor");
  wb_motor_set_position(left_motor, INFINITY);
  wb_motor_set_position(right_motor, INFINITY);
  wb_motor_set_velocity(left_motor, 0.0);
  wb_motor_set_velocity(right_motor, 0.0);
  
  // initialise devices
  gps = wb_robot_get_device("gps");
  wb_gps_enable(gps, TIME_STEP); 

  comp = wb_robot_get_device("comp1");
  wb_compass_enable(comp, TIME_STEP);
  
  toflight = wb_robot_get_device("tof");
  wb_distance_sensor_enable(toflight,TIME_STEP);  
     
}


int main(int argc, char **argv) {

  int state;
  double omegaL, omegaR;
   
  wb_robot_init();

  deviceInit();
  
  state = STATE_ROTATE;
    
  while (wb_robot_step(TIME_STEP) != -1) {
       
    // Compass Sensor

    // Maths angle

    // Distance to target
        
    // GPS Values
     
   
    // State Machine to set the wheel omegas
    switch(state) {
      case STATE_ROTATE:

  
		// Transit to next state
      break;
      
      case STATE_ADVANCE:
		// Set omegas here
		omegaL = 0.0;
		omegaR = 0.0;
      break;
    
    }
  
    wb_motor_set_velocity(left_motor,  omegaL);
    wb_motor_set_velocity(right_motor, omegaR);

  }

  wb_robot_cleanup();

  return 0;
}
